<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$require_variable = 1;
require 'php_scripts/force_https_session_script.php';
require 'php_scripts/login_check_script.php';
require 'php_scripts/db_connect_script.php';
require 'php_scripts/device_manage_script.php';

require 'include/head.php';
echo "<title>Διαχείριση Συσκευής \"$device_name\"</title>";
echo "</head><body>";
require 'include/nav_menu.php';
?>
<div class='modal fade' id='help_modal' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
	<div class='modal-dialog modal-lg'>
		<div class='modal-content'>
			<div class='modal-header'>
				<button type='button' class='close' data-dismiss='modal'><span aria-hidden='true'>&times;</span><span class='sr-only'>Close</span></button>
				<h4 class='modal-title' id='myModalLabel'>Βοήθεια διαχείρισης συσκευής</h4>
			</div>
			<div class='modal-body'>
				<p>Εδώ περιέχονται επιλογές για τον πλήρη έλεγχο της συσκευής και την διαχείρισή της.</p>
				<p>Η σελίδα αυτή χωρίζεται σε 4 μέρη<br />
					<ul>
						<li>Η πρώτη στήλη περιέχει πληροφορίες για την κατάσταση της συσκευής και τα εξαρτήματά της.</li>
						<li>Η δεύτερη στήλη περιέχει τις επιλογές για την εκκίνηση νέου προγράμματος ή την ακύρωση του τρέχοντος</li>
						<li>Η τρίτη στήλη περιέχει την δυνατότητα μετονομασίας της συσκευής καθώς και της λήψης των απαραίτητων αρχείων για τη λειτουργία της συσκευής</li>
						<li>Ο πίνακας στην κάτω γραμμή περιέχει το αρχείο των προγραμμάτων που εκτέλεσε η συσκευή</li>
					</ul>
				</p>
				<p>Οδηγίες χρήσης
					<ul>
						<li>
							Η κατάσταση της συσκευής ανανεώνεται αυτόματα εφόσον η συσκευή είναι ενεργοποιημένη και συνδεδεμένη. Σε αντίθετη περίπτωση, όλες οι τιμές του πίνακα έχουν την τιμή "-".
						</li>
						<br />
						<li>
							Για να εκτελέσετε ή να ακυρώσετε κάποιο πρόγραμμα θα πρέπει η συσκευή να είναι συνδεδεμένη με το σύστημα. Σε αντίθετη περίπτωση, το κουμπί έναρξης/ακύρωσης παραμένει ανενεργό με την ένδειξη "Εκτός σύνδεσης".
							<br /><br />
							Εφόσον η συσκευή δεν εκτελεί κάποιο πρόγραμμα το κουμπί έναρξης/ακύρωσης έχει πράσινο χρώμα με την ένδειξη "'Εναρξη".
							Ο χρήστης μπορεί να επιλέξει το επιθυμητό πρόγραμμα και (εφόσον υποστηρίζεται από το πρόγραμμα) το επιθυμητό βάρος ψωμιού όπως και την απόχρωσή του.
							Αυτόματα ανανεώνεται και ο χρόνος του προγράμματος ανάλογα με τις εκάστοτε απαιτήσεις.
							Σε περίπτωση που ο χρήστης το επιθυμεί, μπορεί να παρατείνει τον χρόνο του προγράμματος επιλέγοντας επιπλέον ώρες ή λεπτά από τα κουμπιά "ώρες" και "λεπτά".
							Αφού επιλέξει τις τιμές που θέλει, πατάει το κουμπί με την ένδειξη "Προσθήκη επιπλέον χρόνου" και η επιλογή του προστίθεται αυτόματα στον χρόνο του προγράμματος.
							Όταν ολοκληρώσει όλες τις επιλογές του μπορεί να ξεκινήσει το πρόγραμμα πατώντας το κουμπί έναρξης/ακύρωσης.
							Σε περίπτωση που η συσκευή έχει σταματήσει αλλά βρίσκεται σε κατάσταση ολοκλήρωσης ή ακύρωσης θα εμφανιστεί ένα μήνυμα που θα ενημερώνει τον χρήστη ότι πιθανώς να υπάρχει ψωμί ή επεξεργασμένα υλικά μέσα στη συσκευή.
							Ο χρήστης μπορεί να ακυρώσει την επιλογή του προγράμματος ή να συνεχίσει με δικιά του ευθύνη.
							Έπειτα, το σύστημα ενημερώνει τον χρήστη ότι η εντολή του εστάλη.
							<br /><br />
							Εφόσον η συσκευή εκτελεί κάποιο πρόγραμμα το κουμπί έναρξης/ακύρωσης έχει κόκκινο χρώμα με την ένδειξη "Ακύρωση".
							Πατώντας το, η συσκευή σταματάει οποιαδήποτε διαδικασία και επανέρχεται στην αρχική της κατάσταση.
							Έπειτα, το σύστημα ενημερώνει τον χρήστη ότι η εντολή του εστάλη.
							
							ΣΗΜΑΝΤΙΚΟ: Συνίσταται ο χρήστης να περιμένει 5-10 δευτερόλεπτα μετά από κάθε εντολή ώστε να σιγουρευτεί για την κατάσταση της συσκευής από τον πίνακα "Κατάσταση συσκευής".
						</li>
						<br />
						<li>
							Στη στήλη μετονομασίας της συσκευής, το τρέχον όνομα αναγράφεται στο πεδίο "Όνομα συσκευής". Εφόσον το επιθυμεί ο χρήστης μπορεί να σβήσει το περιεχόμενο του πεδίου και να γράψει ένα όνομα της δικιάς του επιθυμίας
							<br />
							ΣΗΜΑΝΤΙΚΟ: ένας χρήστης δεν μπορεί να έχει δύο συσκευές με το ίδιο όνομα!
						</li>
						<br />
						<li>
							Τα αρχεία της συσκευής είναι απαραίτητα για τον προγραμματισμό, τη λειτουργία και τη σύνδεσή της με το σύστημα. Ο χρήστης θα πρέπει να έχει λογαριασμό στον ιστοχώρο <a href='http://codebender.cc' target='_blank'>Codebender.cc</a>.
							Μόλις κατεβάσει το αρχείο .ino θα πρέπει να το "ανεβάσει" στον λογαριασμό του και από εκεί να επιλέξει να το φορτώσει στη συσκευή.
							Εναλλακτικά, ο χρήστης θα πρέπει να έχει εγκατεστημένο το <a href='http://arduino.cc/en/main/software#toc1' target='_blank'>Arduino IDE</a> 1.6.X.
							Σε αυτήν την περίπτωση ο χρήστης θα πρέπει να κατεβάσει και το αρχείο της βιβλιοθήκης και να το εγκαταστήσει κάνοντάς το αποσυμπίεση και μεταφορά στον φάκελο των βιβλιοθηκών.
							Έπειτα ανοίγει το αρχείο .ino με το Arduino IDE και το φορτώνει στη συσκευή.
						</li>
					</ul>
				</p>
				<p>Πληροφορίες προγραμμάτων
					<ul>
						<li>
							Πρόγραμμα 1: Βασικό
						</li>
						<li>
							Πρόγραμμα 2: Άσπρο ψωμί/Γαλλικό ψωμί
						</li>
						<li>
							Πρόγραμμα 3: Ολικής Άλεσης
						</li>
						<li>
							Πρόγραμμα 4: Μπισκότα/Γλυκά
						</li>
						<li>
							Πρόγραμμα 5: Κέικ Με Μαγιά
						</li>
						<li>
							Πρόγραμμα 6: Σύντομο Πρόγραμμα, 750gr.
						</li>
						<li>
							Πρόγραμμα 7: Σύντομο Πρόγραμμα, 900gr.
						</li>
						<li>
							Πρόγραμμα 8: Ζύμη
						</li>
						<li>
							Πρόγραμμα 9: Μαρμελάδα
						</li>
						<li>
							Πρόγραμμα 10: Κανονικά Κέικ
						</li>
						<li>
							Πρόγραμμα 11: Τοστ
						</li>
						<li>
							Πρόγραμμα 12: Ψήσιμο
						</li>
						<li>
							Τα προγράμματα 1, 2, 3, 5, και 11 επιτρέπουν στον χρήστη να επιλέξει το βάρος του ψωμιού.
						</li>
						<li>
							Τα προγράμματα 1, 2, 3, 4, 5, 6 και 7 επιτρέπουν στον χρήστη να επιλέξει την απόχρωση του ψωμιού.
						</li>
					</ul>
				</p>
			</div>
		</div>
	</div>
</div>
<div class='container'>
	<div class='row'>
		<?php require 'php_alerts/device_manage_alerts.php'; ?>
	</div>
	<div class='row'>
		<?php echo "<div class='page_title'><a href='device_manage.php?device_id=$device_id'>Διαχείριση Συσκευής</a><sup><a href='#help_modal' id='help' data-toggle='modal'><span class='glyphicon glyphicon-info-sign' aria-hidden='true' aria-label='info'></span></a></sup></div>"; ?>
		<hr />
	</div>
	<div class='row'>
		<div class='col-sm-4 text-center'>
			<label for='device_status_table'>Κατάσταση συσκευής</label>
			<table class='table' id='device_status_table'>
				<tr>
					<td >
						Υπ. χρόνος
					</td>
					<td id='countdown_status'>
					</td>
				</tr>
				<tr>
					<td>
						Πρόγραμμα
					</td>
					<td id='menu_status'>
					</td>
				</tr>
				<tr>
					<td>
						Βάρος
					</td>
					<td id='loafsize_status'>
					</td>
				</tr>
				<tr>
					<td>
						Απόχρωση
					</td>
					<td id='browning_status'>
					</td>
				</tr>
				<tr>
					<td>
						Κατάσταση
					</td>
					<td id='device_status'>
					</td>
				</tr>
				<tr>
					<td>
						Κινητήρας
					</td>
					<td id='motor_status'>
					</td>
				</tr>
				<tr>
					<td>
						Αντίσταση
					</td>
					<td id='heater_status'>
					</td>
				</tr>
			</table>
		</div>
		<div class='col-sm-4 text-center' id='commands_form'>
			<div class='hidden-lg hidden-md hidden-sm'>
				<hr />
			</div>
			<label for='menu_select'>Επιλογή προγράμματος</label>
			<select id='menu_select' class='form-control'>
				<option value='1'>1</option>
				<option value='2'>2</option>
				<option value='3'>3</option>
				<option value='4'>4</option>
				<option value='5'>5</option>
				<option value='6'>6</option>
				<option value='7'>7</option>
				<option value='8'>8</option>
				<option value='9'>9</option>
				<option value='10'>10</option>
				<option value='11'>11</option>
				<option value='12'>12</option>
			</select>
			<label for='loafsize_select'>Επιλογή βάρους ψωμιού</label>
			<select id='loafsize_select' class='form-control'>
				<option value='0'>750gr.</option>
				<option value='1'>900gr.</option>
			</select>
			<label for='browning_select'>Επιλογή απόχρωσης ψωμιού</label>
			<select id='browning_select' class='form-control'>
				<option value='0'>Ανοιχτή</option>
				<option value='1'>Κανονική</option>
				<option value='2'>Σκούρα</option>
			</select>
			<label for='countdown_select'>Χρόνος προγράμματος</label>
			<div id='countdown_select'>
				2:53:00
			</div>
			<div id='countdown_int_select' style='display: none;'>
				10380
			</div>
			<table id='add_countdown_table' width='100%'>
				<tr>
					<td>
						<select id='add_hours' class=' form-control' data-width='25%'>
							<option value='0'>-</option>
							<option value='1'>1</option>
							<option value='2'>2</option>
							<option value='3'>3</option>
							<option value='4'>4</option>
							<option value='5'>5</option>
							<option value='6'>6</option>
							<option value='7'>7</option>
							<option value='8'>8</option>
							<option value='9'>9</option>
							<option value='10'>10</option>
							<option value='11'>11</option>
							<option value='12'>12</option>
							<option value='13'>13</option>
							<option value='14'>14</option>
							<option value='15'>15</option>
							<option value='16'>16</option>
							<option value='17'>17</option>
							<option value='18'>18</option>
							<option value='19'>19</option>
							<option value='20'>20</option>
							<option value='21'>21</option>
							<option value='22'>22</option>
							<option value='23'>23</option>
							<option value='24'>24</option>
							<option value='25'>25</option>
							<option value='26'>26</option>
							<option value='27'>27</option>
							<option value='28'>28</option>
							<option value='29'>29</option>
							<option value='30'>30</option>
							<option value='31'>31</option>
							<option value='32'>32</option>
							<option value='33'>33</option>
							<option value='34'>34</option>
							<option value='35'>35</option>
							<option value='36'>36</option>
							<option value='37'>37</option>
							<option value='38'>38</option>
							<option value='39'>39</option>
							<option value='40'>40</option>
							<option value='41'>41</option>
							<option value='42'>42</option>
							<option value='43'>43</option>
							<option value='44'>44</option>
							<option value='45'>45</option>
							<option value='46'>46</option>
							<option value='47'>47</option>
							<option value='48'>48</option>
							<option value='49'>49</option>
							<option value='50'>50</option>
							<option value='51'>51</option>
							<option value='52'>52</option>
							<option value='53'>53</option>
							<option value='54'>54</option>
							<option value='55'>55</option>
							<option value='56'>56</option>
							<option value='57'>57</option>
							<option value='58'>58</option>
							<option value='59'>59</option>
							<option value='60'>60</option>
							<option value='61'>61</option>
							<option value='62'>62</option>
							<option value='63'>63</option>
							<option value='64'>64</option>
							<option value='65'>65</option>
							<option value='66'>66</option>
							<option value='67'>67</option>
							<option value='68'>68</option>
							<option value='69'>69</option>
							<option value='70'>70</option>
							<option value='71'>71</option>
							<option value='72'>72</option>
							<option value='73'>73</option>
							<option value='74'>74</option>
							<option value='75'>75</option>
							<option value='76'>76</option>
							<option value='77'>77</option>
							<option value='78'>78</option>
							<option value='79'>79</option>
							<option value='80'>80</option>
							<option value='81'>81</option>
							<option value='82'>82</option>
							<option value='83'>83</option>
							<option value='84'>84</option>
							<option value='85'>85</option>
							<option value='86'>86</option>
							<option value='87'>87</option>
							<option value='88'>88</option>
							<option value='89'>89</option>
							<option value='90'>90</option>
							<option value='91'>91</option>
							<option value='92'>92</option>
							<option value='93'>93</option>
							<option value='94'>94</option>
							<option value='95'>95</option>
							<option value='96'>96</option>
							<option value='97'>97</option>
							<option value='98'>98</option>
							<option value='99'>99</option>
						</select>
						ώρες
					</td>
					<td>
						<select id='add_minutes' class='form-control' data-width='25%'>
							<option value='0'>-</option>
							<option value='1'>1</option>
							<option value='2'>2</option>
							<option value='3'>3</option>
							<option value='4'>4</option>
							<option value='5'>5</option>
							<option value='6'>6</option>
							<option value='7'>7</option>
							<option value='8'>8</option>
							<option value='9'>9</option>
							<option value='10'>10</option>
							<option value='11'>11</option>
							<option value='12'>12</option>
							<option value='13'>13</option>
							<option value='14'>14</option>
							<option value='15'>15</option>
							<option value='16'>16</option>
							<option value='17'>17</option>
							<option value='18'>18</option>
							<option value='19'>19</option>
							<option value='20'>20</option>
							<option value='21'>21</option>
							<option value='22'>22</option>
							<option value='23'>23</option>
							<option value='24'>24</option>
							<option value='25'>25</option>
							<option value='26'>26</option>
							<option value='27'>27</option>
							<option value='28'>28</option>
							<option value='29'>29</option>
							<option value='30'>30</option>
							<option value='31'>31</option>
							<option value='32'>32</option>
							<option value='33'>33</option>
							<option value='34'>34</option>
							<option value='35'>35</option>
							<option value='36'>36</option>
							<option value='37'>37</option>
							<option value='38'>38</option>
							<option value='39'>39</option>
							<option value='40'>40</option>
							<option value='41'>41</option>
							<option value='42'>42</option>
							<option value='43'>43</option>
							<option value='44'>44</option>
							<option value='45'>45</option>
							<option value='46'>46</option>
							<option value='47'>47</option>
							<option value='48'>48</option>
							<option value='49'>49</option>
							<option value='50'>50</option>
							<option value='51'>51</option>
							<option value='52'>52</option>
							<option value='53'>53</option>
							<option value='54'>54</option>
							<option value='55'>55</option>
							<option value='56'>56</option>
							<option value='57'>57</option>
							<option value='58'>58</option>
							<option value='59'>59</option>
						</select>
						λεπτά
					</td>
				</tr>
				<tr>
					<td colspan='2'>
						<button type='button' class='btn btn-block btn-primary' id='add_time'>Προσθήκη επιπλέον χρόνου</button>
					</td>
				</tr>
			</table>
			<button type='button' class='btn btn-block form_button disabled' id='command_button'>Εκτός σύνδεσης</button>
			<div class='row blank_row'>
			</div>
		</div>
		<div class='col-sm-4 text-center'>
			<div class='hidden-lg hidden-md hidden-sm'>
				<hr />
			</div>
			<form action='device_manage.php?device_id=<?php echo $device_id;?>' name='device_name_form' method='POST'>
				<label for='device_manage_device_name'>Όνομα συσκευής</label>
  				<input type='text' class='form-control' id='device_manage_device_name' name='device_name'<?php if(isset($new_device_name)) { echo "value='$new_device_name'"; } else { echo "value='$device_name'"; }?>>
  				<input type='submit' class='btn btn-primary btn-block form_button' name='rename' value='Μετονομασία'>
			</form>
			<label for='download_library_form'>Αρχεία συσκευής</label>
			<form action='device_manage.php?device_id=<?php echo $device_id;?>' id='download_library_form' name='download_library_form' method='POST'>
				<div class='btn-group btn-group-justified'>
					<div class='btn-group'>
						<?php echo "<a href='ino_file.php?device_id=$device_id&device_hash=$device_hash' class='btn btn-primary' role='button'><span class='glyphicon glyphicon-download' aria-hidden='true'></span> Αρχείο .ino</a>";?>
					</div>
					<div class='btn-group'>
						<button type='submit' name='download' class='btn btn-primary' type='button'><span class='glyphicon glyphicon-download' aria-hidden='true'></span> Βιβλιοθήκη</button>
					</div>
				</div>
			</form>
		</div>
	</div>
	<?php require 'php_echoes/device_manage_echoes.php'; ?>
	<div class='row'>
		<a href='devices.php'>Πίσω</a>
	</div>		
</div>

<?php
$dbh = NULL;
require 'include/footer.php';
exit();
?>