<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/

//$enable_install = 1; //uncomment this line to enable install tool

if (!isset($enable_install))
{
	header("Location: index.php");
	die();
}

$require_variable = 1;
require 'php_scripts/force_https_session_script.php';
require 'php_scripts/install_script.php';

require 'include/head.php';
echo "<title>Bread Online Installation Tool</title>";
echo "</head><body>";
?>
<div class='jumbotron'>
	<div class='modal fade' id='help_modal' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
		<div class='modal-dialog modal-lg'>
			<div class='modal-content'>
				<div class='modal-header'>
					<button type='button' class='close' data-dismiss='modal'><span aria-hidden='true'>&times;</span><span class='sr-only'>Close</span></button>
					<h4 class='modal-title' id='myModalLabel'>Βοήθεια εγκατάστασης του ιστοχώρου Bread Online</h4>
				</div>
				<div class='modal-body'>
					<p>Αυτή η σελίδα είναι ένα πολύ απλό εργαλείο για την γρήγορη και ασφαλή εγκατάσταση του ιστοχώρου Bread Online στο σύστημά σας.</p>
					<p>Οδηγίες
						<ul>
							<li>1. Συμπληρώστε τη φόρμα με τα στοιχεία του χρήστη root της βάσης δεδομένων σας και επιλέξτε αν ο MySQL server σας τρέχει σε Unix Socket, σε Local ή σε άλλο Host.</li>
							<li>2. Πατήστε το κουμπί "Δημιουργία/Αρχικοποίηση Βάσης". Σε αυτό το βήμα δημιουργείται η βάση που χρειάζεται ο ιστοχώρος για τη λειτουργία του (bread_online) και ένας λογαριασμός χρήστη (bread_root) που έχει πρόσβαση μόνο σε αυτή με μοναδικό κωδικό.</li>
							<li>3. Όταν εμφανιστεί ένα μήνυμα επιτυχίας, πατήστε το κουμπί "Δημιουργία Αρχείου Σύνδεσης".</li>
							<li>4. Αντιγράψτε το αρχείο που δημιουργείται στον φάκελο "bread_online/php_scripts" του φακέλου του ιστοχώρου και δώστε του τα κατάλληλα δικαιώματα (chmod 705).</li>
							<li>5. Καταστρέψτε το session πατώντας το κουμπί "Καταστροφή Session".</li>
							<li>6. Απενεργοποιήστε αυτήν τη σελίδα.</li>
						</ul>
					</p>
					<p>ΠΡΟΣΟΧΗ: Η χρήση αυτού του εργαλείου θα διαγράψει τυχόν βάσεις δεδομένων ή χρήστες με τα ίδια ονόματα. Βεβαιωθείτε ότι έχετε κάνει αντίγραφα ασφαλείας της βάσης σας πριν χρησιμοποιήσετε αυτό το εργαλείο!</p>
				</div>
			</div>
		</div>
	</div>
	<div class='container'>
		<div class='row'>
			<?php require 'php_alerts/install_alerts.php'; ?>
		</div>
		<div class='row text-center'>
			<div class='page_title logged_out'><a href='install.php'>Bread Online Installation Tool</a><sup><a href='#help_modal' id='help' data-toggle='modal'><span class='glyphicon glyphicon-info-sign' aria-hidden='true' aria-label='info'></span></a></sup></div>
		</div>
		<div class='row text-center'>
			<div class='col-md-4'>
			</div>
			<div class='col-md-4'>
				<form action='install.php' class='form-horizontal' name='install_form' method='POST' role='form'>
					<input type='text' id='db_root' name='db_root' class='form-control' placeholder='όνομα χρήστη root'>
					<input type='password' id='db_root_password' name='db_root_password' class='form-control' placeholder='κωδικός χρήστη root'>
					<div id='host_socket_selection' class='btn-group btn-group-justified' data-toggle='buttons'>
						<label class='btn btn-default active'>
							<input type='radio' name='host_socket' value='0' id='option1' autocomplete='off' checked>Host Address
						</label>
						<label class='btn btn-default'>
							<input type='radio' name='host_socket' value='1' id='option2' autocomplete='off'>MySQL Socket
						</label>
					</div>
					<input type='text' id='host_socket_address' name='host_socket_address' class='form-control' placeholder='διεύθυνση Host/MySQL socket'>
					<input name='create_database' class='btn btn-lg btn-primary btn-block form_button' type='submit' value='Δημιουργία/Αρχικοποίηση Βάσης'>
				</form>
				<a href='db_connect_file_generator.php' name='generate_connection_info' class='btn btn-lg btn-primary btn-block form_button'>Δημιουργία Αρχείου Σύνδεσης</a>
				<a href='install.php?logout=1' name='logout' class='btn btn-lg btn-primary btn-block form_button'>Καταστροφή Session</a>
			</div>
			<div class='col-md-4'>
			</div>
		</div>
	</div>
</div> <!--Jumbotron-->

<script src='js/jquery-2.1.4.min.js'></script>
<script src='js/bootstrap.min.js'></script>
</body>
</html>

<?php
exit();
?>