/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$(document).ready(function()
{
	$("#command_button").click(confirm_commands);
	fetch_status();
    setInterval("fetch_status()", 5000);
});

function secondsToTime(secs)
{
    secs = Math.round(secs);
    var hours = Math.floor(secs / (60 * 60));

    var divisor_for_minutes = secs % (60 * 60);
    var minutes = Math.floor(divisor_for_minutes / 60);

    var divisor_for_seconds = divisor_for_minutes % 60;
    var seconds = Math.ceil(divisor_for_seconds);
    
    if (minutes < 10)
    {
    	minutes = "0" + minutes;
    }
    if (seconds < 10)
    {
    	seconds = "0" + seconds;
    }

    var obj = (hours + ":" + minutes + ":" + seconds);
    return obj;
};

function confirm_commands()
{
	$.ajax(
	{
		type: 'POST',
		dataType: 'json',
        url: 'ajax.php',
        data: {user_id: $("#user_id").text(), device_id: $("#device_id").text()},
        success: function(data)
        {
        	if (data["network_status"] == "Online")
        	{
        		if (data["device_status"] == 3 || data["device_status"] == 4)
        		{
        			if (confirm("Ενδεχομένως η συσκευή να περιέχει έτοιμο ψωμί ή επεξεργασμένα υλικά! Είστε σίγουρος/η ότι θέλετε να ξεκινήσετε νέο πρόγραμμα;") == true)
        			{
        				post_commands();
        			}
        		}
        		else
        		{
        			post_commands();
        		}
        	}
        	else
        	{
        		alert("Η συσκευή είναι εκτός σύνδεσης!");
        	}
        }
    });
	
}

function post_commands()
{
    $.ajax(
    {
    	type: 'POST',
    	dataType: 'json',
        url: 'ajax.php',
        data: {user_id: $("#user_id").text(), device_id: $("#device_id").text(), menu_command: $("#menu_select").val(), loafsize_command: $("#loafsize_select").val(), browning_command: $("#browning_select").val(), countdown_command: $("#countdown_int_select").text()},
        success: function(data)
        {
            alert(data["status"]);
        }
    });
};

function fetch_status()
{
	$.ajax(
	{
		type: 'POST',
		dataType: 'json',
        url: 'ajax.php',
        data: {user_id: $("#user_id").text(), device_id: $("#device_id").text()},
        success: function(data)
        {            
            if (data["network_status"] == "Online")
            {
            	$("#command_button").removeClass();
            	$("#command_button").addClass("btn btn-block form_button");
				if(data["motor_status"] == 0)
				{
					data["motor_status"] = "Ανενεργός";
				}
				else if (data["motor_status"] == 1)
				{
					data["motor_status"] = "Ενεργός";
				}
			
				if(data["heater_status"] == 0)
				{
					data["heater_status"] = "Ανενεργή";
				}
				else if (data["heater_status"] == 1)
				{
					data["heater_status"] = "Ενεργή";
				}
			
				if(data["device_status"] == 0)
				{
					data["device_status"] = "Αδρανής";
					$("#command_button").text("Έναρξη");
					$("#command_button").addClass("btn-success");
					$("#command_button").removeClass("btn-danger");
				}
				else if (data["device_status"] == 1)
				{
					data["device_status"] = "Χειροκίνητος έλεγχος";
					$("#command_button").text("Ακύρωση");
					$("#command_button").addClass("btn-danger");
					$("#command_button").removeClass("btn-success");
				}
				else if (data["device_status"] == 2)
				{
					data["device_status"] = "Απομακρυσμένος έλεγχος";
					$("#command_button").text("Ακύρωση");
					$("#command_button").addClass("btn-danger");
					$("#command_button").removeClass("btn-success");
				}
				else if (data["device_status"] == 3)
				{
					data["device_status"] = "Ολοκληρώθηκε";
					$("#command_button").text("Έναρξη");
					$("#command_button").addClass("btn-success");
					$("#command_button").removeClass("btn-danger");
				}
				else if (data["device_status"] == 4)
				{
					data["device_status"] = "Ακυρώθηκε";
					$("#command_button").text("Έναρξη");
					$("#command_button").addClass("btn-success");
					$("#command_button").removeClass("btn-danger");
				}
			
				if(data["loafsize_status"] == 0)
				{
					data["loafsize_status"] = "750gr.";
				}
				else if (data["loafsize_status"] == 1)
				{
					data["loafsize_status"] = "900gr.";
				}
				else if (data["loafsize_status"] == 2)
				{
					data["loafsize_status"] = "-";
				}
			
				if(data["browning_status"] == 0)
				{
					data["browning_status"] = "Ανοιχτή";
				}
				else if (data["browning_status"] == 1)
				{
					data["browning_status"] = "Κανονική";
				}
				else if (data["browning_status"] == 2)
				{
					data["browning_status"] = "Σκούρα";
				}
				else if (data["browning_status"] == 3)
				{
					data["browning_status"] = "-";
            	}
            	$("#menu_status").text(data["menu_status"]);
            	$("#countdown_status").text(secondsToTime(Number(data["countdown_status"])));
            	$("#loafsize_status").text(data["loafsize_status"]);
            	$("#browning_status").text(data["browning_status"]);
            	$("#motor_status").text(data["motor_status"]);
            	$("#heater_status").text(data["heater_status"]);
            	$("#device_status").text(data["device_status"]);
            }
            else
            {
            	$("#command_button").removeClass();
            	$("#command_button").addClass("btn btn-block disabled");
            	$("#menu_status").text("-");
            	$("#countdown_status").text("-");
            	$("#loafsize_status").text("-");
            	$("#browning_status").text("-");
            	$("#motor_status").text("-");
            	$("#heater_status").text("-");
            	$("#device_status").text("-");
            	$("#command_button").removeClass();
            	$("#command_button").addClass("btn btn-block form_button disabled");
            	$("#command_button").text("Εκτός σύνδεσης");
            }
        }
    });
};