<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
echo "<div id='user_id' style='display: none;'>$user_id</div>";
echo "<div id='device_id' style='display: none;'>$device_id</div>";

$sth = $dbh->prepare("SELECT COUNT(*) FROM devices_logs WHERE device_id=:device_id;");
$sth->execute(array(':device_id' => $device_id));
$result = $sth->fetch(PDO::FETCH_NUM);
$rows_num = $result['0'];

if ($rows_num > 0)
{
	echo "<a name='table'>";
	require 'php_pagination/device_manage_pagination.php';
	echo "</a>";
	echo "<div class='row'><table class='table table-hover table-striped'>\n<tr><th>Χρονοσφραγίδα</th><th>Πρόγραμμα</th><th>Μέγεθος</th><th>Απόχρωση</th><th>Υπολειπόμενος Χρόνος</th><th>Κατάσταση</th><th>Μεταβολή Κατάστασης</th></tr>";
	
	$sth = $dbh->prepare("SELECT log_id, timestamp, menu_status, loafsize_status, browning_status, countdown_status, device_status, status_change FROM devices_logs WHERE device_id=:device_id ORDER BY timestamp DESC LIMIT :select_limit OFFSET :select_offset;");
	$sth->execute(array(':device_id' => $device_id, ':select_limit' => $logs_select_limit, ':select_offset' => $logs_select_offset));
	
	while ($result = $sth->fetch())
	{
		$timestamp = $result['timestamp'];
		$menu_status = $result['menu_status'];
		if ($result['loafsize_status'] == 0)
		{
			$loafsize_status = "750gr.";
		}
		else if ($result['loafsize_status'] == 1)
		{
			$loafsize_status = "900gr.";
		}
		else if ($result['loafsize_status'] == 2)
		{
			$loafsize_status = "-";
		}
		if ($result['browning_status'] == 0)
		{
			$browning_status = "Ανοιχτή";
		}
		else if ($result['browning_status'] == 1)
		{
			$browning_status = "Κανονική";
		}
		else if ($result['browning_status'] == 2)
		{
			$browning_status = "Σκούρα";
		}
		else if ($result['browning_status'] == 3)
		{
			$browning_status = "-";
		}
		$countdown_status = $result['countdown_status'];
		if ($result['device_status'] == 0)
		{
			$device_status = "Αδρανής";
		}
		else if ($result['device_status'] == 1)
		{
			$device_status = "Χειροκίνητος Έλεγχος";
		}
		else if ($result['device_status'] == 2)
		{
			$device_status = "Απομακρυσμένος Έλεγχος";
		}
		else if ($result['device_status'] == 3)
		{
			$device_status = "Ολοκλήρωση";
		}
		else if ($result['device_status'] == 4)
		{
			$device_status = "Ακύρωση";
		}
		if ($result['status_change'] == 1)
		{
			$status_change = "Εκκίνηση";
		}
		else if ($result['status_change'] == 2)
		{
			$status_change = "Αδρανοποίηση";
		}
		echo "<tr><td>$timestamp</td><td>$menu_status</td><td>$loafsize_status</td><td>$browning_status</td><td>$countdown_status sec</td><td>$device_status</td><td>$status_change</td></tr>";
	}
	echo "</table></div>";
}
else
{
	echo "<div class='row'><div class='alert alert-info' role='alert'>Αυτή η συσκευή δεν έχει καταγεγραμμένες ενέργειες.</div></div>";
}
?>