<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
$sth = $dbh->prepare("SELECT COUNT(*) FROM devices;");
$sth->execute();
$result = $sth->fetch(PDO::FETCH_NUM);
$rows_num = $result['0'];

if ($rows_num > 0)
{
	require 'php_pagination/devices_admin_pagination.php';
	$devices_sth = $dbh->prepare("SELECT device_id, device_name, registration_timestamp, device_status, user_id FROM devices ORDER BY device_id LIMIT :select_limit OFFSET :select_offset;");
	$devices_sth->execute(array(':select_limit' => $devices_select_limit, ':select_offset' => $devices_select_offset));
	echo "<div class='row'><form action='devices_admin.php' name='devices_admin_form' method='POST'>";
	echo "<table class='table table-hover table-striped'><tr><th><input type='checkbox' name='check_all_devices' value='0'></th><th>Α/Α</th><th>Όνομα Συσκευής</th><th>Χρήστης</th><th>Ημ. Δημιουργίας</th><th>Κατάσταση</th><th></th></tr>\n";
	while ($devices_result = $devices_sth->fetch())
	{
		$users_sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
		$users_sth->execute(array(':user_id' => $devices_result['user_id']));
		$users_result = $users_sth->fetch();
		
		$device_id = $devices_result['device_id'];
		$device_name = $devices_result['device_name'];
		$registration_timestamp = $devices_result['registration_timestamp'];
		if ($devices_result['device_status'] == 0)
		{
			$status = "Αδρανής";
		}
		else if ($devices_result['device_status'] == 1)
		{
			$status = "Χειροκίνητος Έλεγχος";
		}
		else if ($devices_result['device_status'] == 2)
		{
			$status = "Απομακρυσμένος Έλεγχος";
		}
		else if ($devices_result['device_status'] == 3)
		{
			$status = "Ολοκλήρωση";
		}
		else if ($devices_result['device_status'] == 4)
		{
			$status = "Ακύρωση";
		}
		echo "<tr><td><input type='checkbox' name='device_id[]' value='$device_id'></td><td>$device_id</td><td>$device_name</td><td>" . $users_result['user_name'] . "</td><td>$registration_timestamp</td><td>$status</td><td><a href='device_admin_manage.php?device_id=$device_id'>Διαχείριση</a></td></tr>\n";
	}
	echo "</table>";
	echo "<input type='submit' name='delete' class='btn btn-md btn-danger table_button form_button' value='Διαγραφή'>";
	echo "</form></div>";
}
else
{
	echo "<div class='row'><div class='alert alert-info' role='alert'>Δεν υπάρχουν συσκευές.</div></div>";
}
?>