<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
$sth = $dbh->prepare("SELECT COUNT(*) FROM users;");
$sth->execute();
$result = $sth->fetch(PDO::FETCH_NUM);
$rows_num = $result['0'];

require 'php_pagination/users_admin_pagination.php';
$users_sth = $dbh->prepare("SELECT user_id, user_name, user_email, registration_timestamp, user_rank, user_status FROM users LIMIT :select_limit OFFSET :select_offset;");
$users_sth->execute(array(':select_limit' => $users_select_limit, ':select_offset' => $users_select_offset));

echo "<div class='row'><form action='users_admin.php' name='users_admin_form' method='POST'>";
echo "<table class='table table-hover table-striped'><tr><th><input type='checkbox' name='check_all_users' value='0'></th><th>Α/Α</th><th>Όνομα Χρήστη</th><th>Διεύθυνση E-mail</th><th>Βαθμίδα</th><th>Κατάσταση</th><th>Αριθμός Συσκευών</th><th>Ημ. Εγγραφής</th><th></th></tr>\n";
while ($users_result = $users_sth->fetch())
{
	$user_id = $users_result['user_id'];
	$user_email = $users_result['user_email'];
	$devices_sth = $dbh->prepare("SELECT * FROM devices WHERE user_id=:user_id;");
	$devices_sth->execute(array(':user_id' => $user_id));
	$devices_no = $devices_sth->rowCount();
	$registration_timestamp = $users_result['registration_timestamp'];

	if ($users_result['user_rank'] == 0)
	{
		$rank = "Χρήστης";
	}
	else if ($users_result['user_rank'] == 1)
	{
		$rank = "Διαχειριστής";
	}
	if ($users_result['user_status'] == 0)
	{
		$status = "Ανενεργός";
	}
	else if ($users_result['user_status'] == 1)
	{
		$status = "Ενεργός";
	}
	else if ($users_result['user_status'] == 2)
	{
		$status = "Αποκλεισμένος";
	}
	echo "<tr><td><input type='checkbox' name='user_id[]' value='$user_id'></td><td>$user_id</td><td>" . $users_result['user_name'] . "</td><td><a href='mailto:$user_email'>$user_email</a></td><td>$rank</td><td>$status</td><td>$devices_no</td><td>$registration_timestamp</td><td><a href='user_admin_manage.php?user_id=$user_id'>Διαχείριση</a></td></tr>\n";
}
echo "</table>";
echo "<input type='submit' name='delete' class='btn btn-md btn-danger table_button form_button' value='Διαγραφή'>";
echo "</form><hr /></div>";
?>