<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
if (isset($_POST['create_database']))
{
	$root_user = strip_tags($_POST['db_root']);
	$root_pass = strip_tags($_POST['db_root_password']);
	if (intval($_POST['host_socket']) == 0)
	{
		$host_socket = "host";
	}
	else if (intval($_POST['host_socket']) == 1)
	{
		$host_socket = "unix_socket";
	}
	$host_address = strip_tags($_POST['host_socket_address']);

	try
	{
		global $dbh;
		if ($host_socket == "host")
		{
			$dbh = new PDO("mysql:host=$host_address", $root_user, $root_pass);
		}
		else if ($host_socket == "unix_socket")
		{
			$dbh = new PDO("mysql:unix_socket=$host_address", $root_user, $root_pass);
		}
		$dbh->setAttribute(PDO::ATTR_EMULATE_PREPARES, FALSE);
		$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$dbh->setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
	}
	catch(PDOException $e)
	{
		$_SESSION['failed'] = 1;
		if (isset($_SESSION['host_address']))
		{
			unset($_SESSION['host_address']);
		}
		if (isset($_SESSION['host_socket']))
		{
			unset($_SESSION['host_socket']);
		}
		header("Location: install.php");
		die();
	}
	
	$user_pass = md5(rand());
	
	$create_database_query = "
		SET SQL_MODE = \"NO_AUTO_VALUE_ON_ZERO\";
		SET time_zone = \"+00:00\";
		DROP DATABASE IF EXISTS bread_online;
		CREATE DATABASE IF NOT EXISTS `bread_online` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
		USE `bread_online`;

		CREATE TABLE IF NOT EXISTS `commands` (
		  `commands_timestamp` datetime NOT NULL,
		  `device_id` int(11) NOT NULL,
		  `menu_command` smallint(3) NOT NULL DEFAULT '1',
		  `loafsize_command` tinyint(1) NOT NULL DEFAULT '0',
		  `browning_command` tinyint(1) NOT NULL DEFAULT '0',
		  `countdown_command` int(11) NOT NULL DEFAULT '10380',
		  `start_command` tinyint(1) NOT NULL DEFAULT '0',
		  `stop_command` tinyint(1) NOT NULL DEFAULT '0'
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;

		CREATE TABLE IF NOT EXISTS `devices` (
		`device_id` int(11) NOT NULL,
		  `device_hash` varchar(32) NOT NULL,
		  `registration_timestamp` datetime NOT NULL,
		  `menu_status` tinyint(2) DEFAULT NULL,
		  `loafsize_status` tinyint(1) DEFAULT NULL,
		  `browning_status` tinyint(1) DEFAULT NULL,
		  `device_status` tinyint(1) DEFAULT NULL,
		  `countdown_status` int(11) DEFAULT NULL,
		  `motor_status` tinyint(1) DEFAULT NULL,
		  `heater_status` tinyint(1) DEFAULT NULL,
		  `update_timestamp` datetime DEFAULT NULL,
		  `device_name` varchar(40) NOT NULL,
		  `user_id` int(11) NOT NULL
		) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

		CREATE TABLE IF NOT EXISTS `devices_logs` (
		`log_id` bigint(20) NOT NULL,
		  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
		  `device_id` int(11) NOT NULL,
		  `menu_status` tinyint(2) NOT NULL,
		  `loafsize_status` tinyint(1) NOT NULL,
		  `browning_status` tinyint(1) NOT NULL,
		  `countdown_status` int(11) NOT NULL,
		  `device_status` tinyint(1) NOT NULL,
		  `status_change` tinyint(1) DEFAULT NULL
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;

		CREATE TABLE IF NOT EXISTS `menus_info` (
		`menu_id` smallint(6) NOT NULL,
		  `menu` tinyint(2) NOT NULL,
		  `loafsize` tinyint(1) DEFAULT NULL,
		  `countdown` int(10) unsigned DEFAULT NULL
		) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;

		INSERT INTO `menus_info` (`menu_id`, `menu`, `loafsize`, `countdown`) VALUES
		(1, 1, 0, 10380),
		(2, 1, 1, 10800),
		(3, 2, 0, 13200),
		(4, 2, 1, 13800),
		(5, 3, 0, 12720),
		(6, 3, 1, 13200),
		(7, 4, 2, 6000),
		(8, 5, 0, 10200),
		(9, 5, 1, 10500),
		(10, 6, 0, 3480),
		(11, 7, 1, 3480),
		(12, 8, 1, 5400),
		(13, 9, 2, 4800),
		(14, 10, 2, 10200),
		(15, 11, 0, 10500),
		(16, 11, 1, 10800),
		(17, 12, 2, 3600);

		CREATE TABLE IF NOT EXISTS `password_reset` (
		  `user_id` int(11) NOT NULL,
		  `password_reset_hash` varchar(32) NOT NULL,
		  `timestamp` datetime NOT NULL
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;

		CREATE TABLE IF NOT EXISTS `users` (
		`user_id` int(11) NOT NULL,
		  `user_name` varchar(40) NOT NULL,
		  `password_hash` varchar(32) NOT NULL,
		  `user_status` tinyint(1) NOT NULL DEFAULT '0',
		  `user_email` varchar(40) NOT NULL,
		  `registration_timestamp` datetime NOT NULL,
		  `user_rank` tinyint(1) NOT NULL DEFAULT '0'
		) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

		INSERT INTO `users` (`user_id`, `user_name`, `password_hash`, `user_status`, `user_email`, `registration_timestamp`, `user_rank`) VALUES
		(1, 'root', 'ed035e641355c6e2a0ddc3a986ba51fd', 1, 'demo@demo.com', NOW(), 1);

		CREATE TABLE IF NOT EXISTS `users_logs` (
		`log_id` bigint(20) NOT NULL,
		  `timestamp` datetime NOT NULL,
		  `user_name` varchar(40) NOT NULL,
		  `action_description` text NOT NULL
		) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

		CREATE TABLE IF NOT EXISTS `user_activation` (
		  `user_id` int(11) NOT NULL,
		  `activation_hash` varchar(32) NOT NULL
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;

		ALTER TABLE `commands`
		 ADD PRIMARY KEY (`device_id`);

		ALTER TABLE `devices`
		 ADD PRIMARY KEY (`device_id`), ADD KEY `user_id` (`user_id`);

		ALTER TABLE `devices_logs`
		 ADD PRIMARY KEY (`log_id`), ADD KEY `device_id` (`device_id`);

		ALTER TABLE `menus_info`
		 ADD PRIMARY KEY (`menu_id`);

		ALTER TABLE `password_reset`
		 ADD KEY `user_id` (`user_id`);

		ALTER TABLE `users`
		 ADD PRIMARY KEY (`user_id`), ADD UNIQUE KEY `user_name` (`user_name`), ADD UNIQUE KEY `user_email` (`user_email`);

		ALTER TABLE `users_logs`
		 ADD PRIMARY KEY (`log_id`), ADD KEY `user_name` (`user_name`);

		ALTER TABLE `user_activation`
		 ADD PRIMARY KEY (`user_id`);

		ALTER TABLE `devices`
		MODIFY `device_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

		ALTER TABLE `devices_logs`
		MODIFY `log_id` bigint(20) NOT NULL AUTO_INCREMENT;

		ALTER TABLE `menus_info`
		MODIFY `menu_id` smallint(6) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=18;

		ALTER TABLE `users`
		MODIFY `user_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;

		ALTER TABLE `users_logs`
		MODIFY `log_id` bigint(20) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

		ALTER TABLE `commands`
		ADD CONSTRAINT `commands_ibfk_1` FOREIGN KEY (`device_id`) REFERENCES `devices` (`device_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

		ALTER TABLE `devices`
		ADD CONSTRAINT `devices_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`user_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

		ALTER TABLE `password_reset`
		ADD CONSTRAINT `password_reset_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`user_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

		ALTER TABLE `user_activation`
		ADD CONSTRAINT `user_activation_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`user_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

		GRANT USAGE ON *.* TO 'bread_root'@'localhost';
		DROP USER 'bread_root'@'localhost';
		CREATE USER 'bread_root'@'localhost' IDENTIFIED BY '$user_pass';
		GRANT ALL PRIVILEGES ON `bread_online`.* TO 'bread_root'@'localhost' WITH GRANT OPTION;
	";

	$dbh->exec($create_database_query);
	$_SESSION['installed'] = 1;
	$_SESSION['host_socket'] = $host_socket;
	$_SESSION['host_address'] = $host_address;
	$_SESSION['user_pass'] = $user_pass;
}
?>