<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
if (isset($_GET['device_id']) && isset($_GET['user_id']) && intval($_GET['device_id']) && intval($_GET['user_id']))
{
	$device_id = intval($_GET['device_id']);
	$user_id = intval($_GET['user_id']);
	$sth = $dbh->prepare("SELECT device_name, device_hash, user_id FROM devices WHERE device_id=:device_id LIMIT 1;");
	$sth->execute(array(':device_id' => $device_id));
	if ($sth->rowCount() == 1)
	{
		$result = $sth->fetch();
		if ($user_id == $result['user_id'])
		{
			$user_id = $result['user_id'];
			$device_name = $result['device_name'];
			$device_hash = $result['device_hash'];
		}
		else
		{
			$dbh = NULL;
			$_SESSION['inv_link'] = 1;
			header("Location: users_admin.php");
			die();
		}
	}
	else
	{
		$dbh = NULL;
		$_SESSION['inv_link'] = 1;
		header("Location: users_admin.php");
		die();
	}
}
else
{
	$dbh = NULL;
	$_SESSION['inv_link'] = 1;
	header("Location: users_admin.php");
	die();
}

if (isset($_POST['download']))
{
  	$file = "arduino_libraries_fc364cf24bda073b467a75c1520e2ecf/Nokia5110-master.zip";
  	header("Content-type: application/zip");
  	header("Content-length: " . filesize($file));
  	header("Content-disposition: attachment; filename='Nokia5110-master.zip'");
  	readfile($file);
}

if (isset($_POST['delete']))
{
	if (isset($_POST['log_id']))
	{
		$list = $_POST['log_id'];
		$N = count($list);
		for ($i = 0; $i < $N; $i++)
		{
			$list[$i] = intval($list[$i]);
			$sth = $dbh->prepare("DELETE FROM devices_logs WHERE log_id=:log_id LIMIT 1;");
			$sth->execute(array(':log_id' => $list[$i]));
		}
	}
	else
	{
		$no_selections = 1;
	}
}

if (isset($_POST['rename']))
{
	if ($_POST['device_name'])
	{
		$new_device_name = strip_tags($_POST['device_name']);
		if (strlen($new_device_name) < 41)
		{
			if ($new_device_name != $device_name)
			{
				$sth = $dbh->prepare("SELECT device_id FROM devices WHERE device_name=:device_name AND user_id=:user_id LIMIT 1;");
				$sth->execute(array(':device_name' => $new_device_name, ':user_id' => $user_id));
				if ($sth->rowCount() == 0)
				{
					$sth = $dbh->prepare("UPDATE devices SET device_name=:device_name WHERE device_id=:device_id LIMIT 1;");
					$sth->execute(array(':device_name' => $new_device_name, ':device_id' => $device_id));
					
					$sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
					$sth->execute(array(':user_id' => $user_id));
					$result = $sth->fetch();
					
					$user_name = $result['user_name'];
					$admin_name = $_SESSION['user_name'];
					$admin_id = $_SESSION['id'];
					$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) μετονόμασε τη συσκευή \"$device_name\" (Α/Α: $device_id) που ανήκει στον χρήστη \"$user_name\" (Α/Α: $user_id) σε \"$new_device_name\".";
					$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
					
					$device_name = $new_device_name;
					$name_changed = 1;
				}
				else
				{
					$inv_device_name = 1;
				}
			}
		}
		else
		{
			$long_name = 1;
		}
	}
	else
	{
		$empty_form = 1;
	}
}
?>