<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$require_variable = 1;
require 'php_scripts/force_https_session_script.php';
require 'php_scripts/reset_password_script.php';

require 'include/head.php';
echo "<title>Επαναφορά Κωδικού</title>";
echo "</head><body>";
require 'include/nav_menu.php';
?>

<div class='container'>
	<div class='row'>
		<?php require 'php_alerts/reset_password_alerts.php'; ?>
	</div>
	<div class='row'>
		<div class='col-sm-7 col-md-8 hidden-xs'>
			<div class='panel panel-default' id='about_panel'>
				<div class='panel-heading'>
					<h3 class='panel-title'>Σχεδιασμός και μετατροπή μιας απλής οικιακής συσκευής σε επαναπρογραμματιζόμενη συσκευή IP</h3>
				</div>
				<div class='panel-body'>
					Ο ιστοχώρος αυτός αποτελεί μέρος διπλωματικής εργασίας με στόχο τη μετατροπή μιας ήδη υπάρχουσας ηλεκτρικής συσκευής, και πιο συγκεκριμένα ενός αρτοπαρασκευαστή, έτσι ώστε να είναι διαχειρίσιμη μέσω IP.
					Η μετατροπή της συσκευής έγινε με τη χρήση ενός μικροελεγκτή Arduino, στον οποίο χρησιμοποιήθηκε και μία διασύνδεση TCP/IP (Ethernet Shield), ο οποίος ελέγχει τις επιμέρους συσκευές του αρτοπαρασκευαστή (κινητήρας και αντίσταση) έτσι ώστε να υλοποιείται το πρόγραμμα το οποίο υπήρχε στον αρχικό επεξεργαστή της συσκευής. 
					Επιπλέον, δίνεται η δυνατότητα επαναπρογραμματισμού του ελεγκτή αυτού είτε για να προστεθούν επιπλέον λειτουργίες, είτε να τροποποιηθούν, είτε να απενεργοποιηθούν ήδη υπάρχουσες.
					Από την άλλη, ο ιστοχώρος αυτός επιτρέπει τη δυναμική διαχείριση πολλαπλών συσκευών από πολλούς χρήστες δίνοντας τη δυνατότητα η ιδέα αυτή να επεκταθεί και σε άλλες συσκευές.
					<br /><br />
					Η εργασία αυτή εκπονήθηκε από τον Παναγιώτη Ιωαννίδη, φοιτητή του τμήματος Μηχανικών Πληροφορικής & Τηλεπικοινωνιών του Πανεπιστημίου Δυτικής Μακεδονίας, υπό την εποπτεία του καθηγητή Δρ. Μηνά Δασυγένη.
				</div>
			</div>
		</div>
		<div class='col-sm-2 col-md-1 hidden-xs'>
		</div>
		<div class='col-sm-4 col-md-3'>
			<div class='page_title logged_out'><a href='reset_password.php'>Επαναφορά Κωδικού</a></div>
			<form action='reset_password.php' name='register_form' method='POST' role='form'>
   	 			<input type='password' id='password_reset_password' name='new_password' class='form-control' placeholder='νέος κωδικός'>
   	 			<input type='password' id='password_confirm_reset_password' name='confirm_new_password' class='form-control' placeholder='επιβεβαίωση νέου κωδικού'>
        		<input name='pass_reset' id='register_button' class='btn btn-lg btn-primary btn-block form_button' type='submit' value='Επαναφορά Κωδικού'>
    		</form>
			<div class='under_button_link'><a href='index.php'>Αρχική Σελίδα</a></div>
		</div>
	</div>
</div>
<?php
require 'include/footer.php';
exit();
?>